// bathroom 1d cellular automata patterns

_global.offset_x = 6;
_global.offset_y = 6;
_global.tile_width = 10;
_global.tile_height = 10;
_global.wall_width = 64;
_global.wall_height = 29;
_global.cells = new Array();
//_global.rules = [ [ [1, 0], [1, 0] ], [ [ 1, 0], [1, 0] ] ];
//_global.rules = [ [ [1, 0], [0, 1] ], [ [ 0, 0], [1, 0] ] ];
//_global.rules = [ [ [1, 0], [1, 1] ], [ [ 0, 1], [1, 0] ] ];
//_global.rules = [ [ [0, 1], [0, 0] ], [ [ 0, 1], [1, 0] ] ];
//_global.rules = [ [ [0, 1], [1, 1] ], [ [ 1, 1], [1, 0] ] ];
_global.rules = [ [ [0, 0], [0, 0] ], [ [ 0, 0], [0, 0] ] ];
// 10 11 01 10 = m
// 01 00 01 10
//
// 0,1,0,0,1,0,1,0
// 0,1,1,0,1,0,1,0

setup_tiles.text = "Setting up "+(wall_width*wall_height)+" tiles...";

MovieClip.prototype.cell_on = function () {
	this.gotoAndStop("black");
}

MovieClip.prototype.cell_off = function () {
	this.gotoAndStop("white");
}

_global.init_tiles = function () {
//	trace("initing tiles...");
	for (var i=0; i<wall_width; i++) {
		for (var j=0;j<wall_height; j++) {
			_root.attachMovie("tile","tile_"+i+"_"+j, get_serial());
			var myTile = eval("_root.tile_"+i+"_"+j);
			myTile._x = i*tile_width + offset_x;
			myTile._y = j*tile_height + offset_y;
			myTile._height = tile_height;
			myTile._width = tile_width;
			// myTile._visible = false;
		}
	}

	_root.ruleNum.swapDepths(get_serial());
//	trace(" tiles inited.");
}

_global.run_ca = function () {
//	trace("randomizing top row...");
	// randomize cells
	for (var i=0; i<wall_width; i++) {
		var myTile = eval("_root.tile_"+i+"_0");
		if (Math.random() < .5) {
			_global.cells[i] = 1;
			myTile.cell_on();
			//myTile._visible = true;
		} else {
			_global.cells[i] = 0;
			myTile.cell_off();
			//myTile._visible = false;
		}
	}
//	trace(" top row randomized.");
	
	_global.working_row = 0;
	_global.row_interval = setInterval(render_row, 100);
}

_global.render_row = function () {
	var i = _global.working_row;
	if (i < wall_height) {
		_global.working_row++;
	} else {
		clearInterval(_global.row_interval);
		return;
	}
	
		var nextRow = new Array();
		for (var j=0; j<wall_width; j++) {
//			trace("I: "+i+"  J: "+j);
			var x = j-1;
			var y = j;
			var z = j+1;
			if (x < 0) { x = wall_width-1; }
			if (z >= wall_width) { z = 0; }

			nextRow[j] = rules[cells[x]][cells[y]][cells[z]];
			
			var myTile = eval("_root.tile_"+j+"_"+(i+1));
			if (nextRow[j] == 1) {
				myTile.cell_on();
			} else {
				myTile.cell_off();
			}
		}
		updateAfterEvent();
		_global.cells = nextRow;

}

_global.set_rules = function (code) {
	var x;
	_root.ruleNum.num.text = "Ruleset #"+code;
	_global.current_ruleset = code;
	
	// unrolling the loop!  woo!
	
	x = Math.floor(code/128);
	_global.rules[0][0][0] = x;
	code = code - (x*128);
	
	x = Math.floor(code/64);
	_global.rules[0][0][1] = x;
	code = code - (x*64);
	
	x = Math.floor(code/32);
	_global.rules[0][1][0] = x;
	code = code - (x*32);
	
	x = Math.floor(code/16);
	_global.rules[0][1][1] = x;
	code = code - (x*16);
	
	x = Math.floor(code/8);
	_global.rules[1][0][0] = x;
	code = code - (x*8);
	
	x = Math.floor(code/4);
	_global.rules[1][0][1] = x;
	code = code - (x*4);
	
	x = Math.floor(code/2);
	_global.rules[1][1][0] = x;
	code = code - (x*2);
	
	_global.rules[1][1][1] = code;
	
//	trace(rules);
	run_ca();
//	trace(" rules set.");
}

// ---

_global.serial_number = 1000;
_global.get_serial = function () {
	return _global.serial_number++;
}

keyListener = new Object();
keyListener.onKeyDown = function () {
	var keyCode = Key.getCode();
	var ruleset_code;
	
	//trace(keyCode);
	if (keyCode == 32) {
		ruleset_code = int(Math.random()*256);
	}
	else if (keyCode == 187 || keyCode == 107) {
		ruleset_code = _global.current_ruleset + 1;
	}
	else if (keyCode == 189 || keyCode == 109) {
		ruleset_code = _global.current_ruleset - 1;
	}
	
	set_rules(ruleset_code);
}
Key.addListener(keyListener);

set_rules(129);


